import os
import py_compile


def obfuscate_file(file_path: str, output_dir: str):
    os.makedirs(output_dir, exist_ok=True)

    py_compile.compile(file_path, cfile=os.path.join(output_dir, os.path.basename(file_path) + 'c'), optimize=0)
    print(f"Compiled file: {file_path} to {output_dir}")


def obfuscate_dir(dir_path: str, output_dir: str):
    """ Generated by chatgpt, Might not work since i didin't test this yet. """

    os.makedirs(output_dir, exist_ok=True)

    for root, _, files in os.walk(dir_path):
        for file in files:
            if file.endswith('.py'):
                file_path = os.path.join(root, file)
                rel_path = os.path.relpath(file_path, dir_path)
                output_file = os.path.join(output_dir, rel_path + 'c')

                os.makedirs(os.path.dirname(output_file), exist_ok=True)
                py_compile.compile(file_path, cfile=output_file, optimize=0)
                print(f"Compiled file: {file_path} to {output_file}")


def obfuscate(path: str, output_dir: str = 'compiled_files'):
    if os.path.isfile(path):
        obfuscate_file(path, output_dir)
    elif os.path.isdir(path):
        obfuscate_dir(path, output_dir)
    else:
        print(f"The path {path} is neither a file nor a directory or does not exist.")
